#include <CoreFoundation/CoreFoundation.h>

#define MAX_INTEL_HEX_RECORD_LENGTH 16
typedef struct _INTEL_HEX_RECORD
{
   UInt32  	Length;
   UInt32 	Address;
   UInt32  	Type;
   UInt8  	Data[MAX_INTEL_HEX_RECORD_LENGTH];
} INTEL_HEX_RECORD, *PINTEL_HEX_RECORD;


int main (int argc, const char * argv[]) {
    // insert code here...
	
	FILE *inFile, *outFile;
	INTEL_HEX_RECORD current;
	
	char colon;
	UInt16 count, conversions;
	UInt32 currentByte;
	
	char data[3];
	
	
	if (argc != 3)
	{
		printf("Proper usage: HexToC source.hex dest.c\n");
		exit(0);
	}
	
	
	inFile = fopen(argv[1], "r");
	
	
	if (inFile == NULL)
	{
		printf("Could not open source file\n");
		exit(1);
	}
	
	outFile = fopen(argv[2], "w");

	
	if (outFile == NULL)
	{
		printf("Could not create destination file\n");
		exit(1);
	}
	
	//start the new file
	
	fprintf(outFile, "INTEL_HEX_RECORD accesHex[] = {\n");
	
	data[2] = '\0';
	
	do
	{
		colon = getc(inFile);
		
		if (colon != ':')
		{
			printf("A line did not begin with a colon");
			close(inFile); close(outFile);
			exit(2);
		}

		conversions = fscanf(inFile,"%2lX%4lX%2lX", &current.Length, &current.Address, &current.Type);
		
		if (conversions != 3)
		{
			printf("Could not read line preamble\n");
			close(inFile); close(outFile);
			exit(3);
		}
		
		if (current.Length > MAX_INTEL_HEX_RECORD_LENGTH)
		{
			printf("Specified length is too long\n");
			close(inFile); close(outFile);
			exit(4);
		}
		
		for (count = 0; count < current.Length; count++)
		{
			/*
			conversions = fscanf(inFile, "%2lX", &currentByte);
			
			if (conversions != 1)
			{
				printf("Early line termination.\n");
				close(inFile); close(outFile);
				exit(5);
			}
			
			*/
			
			data[0] = getc(inFile);
			data[1] = getc(inFile);
			
			sscanf(data, "%X", &currentByte);
			
			
			current.Data[count] = currentByte;
		}
		
		fscanf(inFile, "%2lx", &currentByte); //discard the checksum
		getc(inFile); //get rid of carriage return
		getc(inFile);//get rid of newline character
		
		//need to write out the current record to the file
		fprintf(outFile, "   {\n");
		fprintf(outFile, "      %d,\n", current.Length);
		fprintf(outFile, "      0x%04x,\n", current.Address);
		fprintf(outFile, "      %d,\n", current.Type);
		fprintf(outFile, "      {");
		
		if (current.Type != 1)
		{
		
			for (count = 0; count < current.Length; count ++)
			{
				fprintf(outFile, "0x%02x", current.Data[count]);
				
				if (count == (current.Length - 1))
					fprintf(outFile, "}\n");
				else
					fprintf(outFile, ",");
			}
			
			fprintf(outFile,"    },\n");
		}
	
	}while (current.Type != 1);
	
	fprintf(outFile, "0}\n");
	fprintf(outFile, "   }\n");
	fprintf(outFile, "};");

	close(inFile); close(outFile);
	
    return 0;
}
